# ----------------------------------------------------------------------------------------------
# ------------------------------ Activities on differernt  phases ------------------------------
# ----------------------------------------------------------------------------------------------
fossanalyze.active_phase <- function (saveFile=FALSE, file="active_phase") {

# Plot constants 
fileName <- paste(file, "", sep = "")

phaseCnt <- c()
ind <- 1
len <- length(foss$CB_WHICH_MEASURES_DESIGN_PERS)
while(ind <= len) {
	phaseCnt[ind] <- 4
	# Design phase
	if(length(grep("None at all", foss$CB_WHICH_MEASURES_DESIGN_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	if(length(grep("Don't know", foss$CB_WHICH_MEASURES_DESIGN_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	
	# Implemetation phase
	if(length(grep("None at all", foss$CB_WHICH_MEASURES_IMPL_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	if(length(grep("Don't know", foss$CB_WHICH_MEASURES_IMPL_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}

	# Test phase
	if(length(grep("None at all", foss$CB_WHICH_MEASURES_TEST_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	if(length(grep("Don't know", foss$CB_WHICH_MEASURES_TEST_PERS[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	
	# Maintance phase
	if(length(grep("None at all", foss$CB_WHICH_MEASURES_MAINTNC_ALL[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}
	if(length(grep("Don't know", foss$CB_WHICH_MEASURES_MAINTNC_ALL[ind])) == 1) {
		phaseCnt[ind] <- phaseCnt[ind] - 1
	}

	ind <- ind + 1
}

phases <- c(0, 0, 0, 0, 0)
ind <- 1
len <- length(foss$CB_WHICH_MEASURES_DESIGN_PERS)
while(ind <= len) {
	if(phaseCnt[ind] == 0)
		phases[1] <- phases[1] + 1	
	if(phaseCnt[ind] == 1)
		phases[2] <- phases[2] + 1	
	if(phaseCnt[ind] == 2)
		phases[3] <- phases[3] + 1	
	if(phaseCnt[ind] == 3)
		phases[4] <- phases[4] + 1	
	if(phaseCnt[ind] == 4)
		phases[5] <- phases[5] + 1	
	ind <- ind + 1
}

phasesLab <- c("Conducting\nno measures", 
               "Conducting\nmeasures\non 1 phase", 
	       "Conducting\nmeasures\non 2 phases", 
	       "Conducting\nmeasures\non 3 phases", 
	       "Conducting\nmeasures\non 4 phases")

plotMatrix <- matrix(phases , nrow = 1, ncol = length(phases), byrow = FALSE, dimnames = list("", phasesLab))

# if "saveFile", than save as png image:
if (saveFile) png(paste(fileName, "png", sep="."), width=600, height=600)

par(mai = c(1.2, 1.2, 0.7, 0)) # margin size (bottom, left, top, right) specified in inches. 
par(mgp = c(4.5, 2, 0)) # margin line for (the axis title, axis labels, axis line)
par(cex.lab = 1.4) # label size 

barplot(plotMatrix, beside = FALSE, cex.names = 1.0, axis.lty = 0,
        col = c("lightskyblue"),
        main="How many participants conduct measures\non different phases?", 
	ylab="Number of participants", 
	xlab="",
        ylim = c(0, 40))
grid(0, 10)

# if "saveFile", stop output-redirection to file
if (saveFile) dev.off()

}

#Function call with different parameters
isSaveFile <- TRUE
fossanalyze.active_phase(isSaveFile)
