# ----------------------------------------------------------------------------------------------
# ----- Measures for security assurance Project defined vs. Personally by number of people -----
# ----------------------------------------------------------------------------------------------
fossanalyze.measure_proj_vs_pers_people <- function (saveFile=FALSE, projectSize="small", projectPhase="design", file="measure") {

# Plot constants 
if(projectSize == "small") {
    projectSizeText <- "UNDER 10 MEMBERS"
    fileName <- paste(file, "_small_proj", sep = "")
} else {
    projectSizeText <- "OVER 10 MEMEBERS"
    fileName <- paste(file, "_big_proj", sep = "")
}

if(projectPhase == "design") {
    projectPhaseText <- "DESIGN"
    measures <- designMeasures
    measuresLab <- designMeasuresLab
    
    if(projectSize == "small") {
        nmAll_1 <- foss$CB_WHICH_MEASURES_DESIGN_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_2 <- foss$CB_WHICH_MEASURES_DESIGN_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_1), as.character(nmAll_2))
	nmPers_1 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_2 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_1), as.character(nmPers_2))
    } else {
        nmAll_3 <- foss$CB_WHICH_MEASURES_DESIGN_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_4 <- foss$CB_WHICH_MEASURES_DESIGN_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_5 <- foss$CB_WHICH_MEASURES_DESIGN_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_3), as.character(nmAll_4), as.character(nmAll_5))
	nmPers_3 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_4 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_5 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_3), as.character(nmPers_4), as.character(nmPers_5))
    } 
    fileName <- paste(fileName, "_design", sep = "")
} else if(projectPhase == "impl") {
    projectPhaseText <- "IMPLEMENTATION"
    measures <- implMeasures
    measuresLab <- implMeasuresLab
    
    if(projectSize == "small") {
        nmAll_1 <- foss$CB_WHICH_MEASURES_IMPL_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_2 <- foss$CB_WHICH_MEASURES_IMPL_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_1), as.character(nmAll_2))
	nmPers_1 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_2 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_1), as.character(nmPers_2))
    } else {    
        nmAll_3 <- foss$CB_WHICH_MEASURES_IMPL_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_4 <- foss$CB_WHICH_MEASURES_IMPL_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_5 <- foss$CB_WHICH_MEASURES_IMPL_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_3), as.character(nmAll_4), as.character(nmAll_5))
	nmPers_3 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_4 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_5 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_3), as.character(nmPers_4), as.character(nmPers_5))
    } 
    fileName <- paste(fileName, "_impl", sep = "")
} else if(projectPhase == "test") {
    projectPhaseText <- "TESTING"
    measures <- testMeasures
    measuresLab <- testMeasureslab
    
    if(projectSize == "small") {
        nmAll_1 <- foss$CB_WHICH_MEASURES_TEST_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_2 <- foss$CB_WHICH_MEASURES_TEST_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_1), as.character(nmAll_2))
	nmPers_1 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_2 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_1), as.character(nmPers_2))
    } else {    
        nmAll_3 <- foss$CB_WHICH_MEASURES_TEST_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_4 <- foss$CB_WHICH_MEASURES_TEST_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_5 <- foss$CB_WHICH_MEASURES_TEST_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_3), as.character(nmAll_4), as.character(nmAll_5))
	nmPers_3 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_4 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_5 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_3), as.character(nmPers_4), as.character(nmPers_5))
    } 
    fileName <- paste(fileName, "_test", sep = "")
} else {
    projectPhaseText <- "MAINTENANCE"
    measures <- mainMeasures
    measuresLab <- mainMeasuresLab
    
    if(projectSize == "small") {
        nmAll_1 <- foss$CB_WHICH_MEASURES_MAINTNC_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_2 <- foss$CB_WHICH_MEASURES_MAINTNC_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_1), as.character(nmAll_2))
	nmPers_1 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[1], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_2 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[2], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_1), as.character(nmPers_2))
     } else {   
        nmAll_3 <- foss$CB_WHICH_MEASURES_MAINTNC_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_4 <- foss$CB_WHICH_MEASURES_MAINTNC_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll_5 <- foss$CB_WHICH_MEASURES_MAINTNC_ALL[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmAll <- c(as.character(nmAll_3), as.character(nmAll_4), as.character(nmAll_5))
	nmPers_3 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[3], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_4 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[4], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers_5 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_PEOPLE %in% grep(projSizes[5], foss$RB_HOW_MANY_PEOPLE, value=TRUE)]
        nmPers <- c(as.character(nmPers_3), as.character(nmPers_4), as.character(nmPers_5))
    } 
    fileName <- paste(fileName, "_main", sep = "")
}

mainText <- paste("Measures for security assurance used during \nthe ", projectPhaseText, " in Project with ", projectSizeText, ".", sep = "")
ylabText=percenText;
xlabText="Conducted measures";
legendLab <- c("Conducted by other project members", "Conducted personally")

#Normirung Maximal Wert
normMax <- 100

nmAllLen <- length(nmAll)
nmPersLen <- length(nmPers)

if(length(measures)>=1)
measures_1 <- c(length(nmAll[nmAll %in% grep(measures[1], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[1], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=2)
measures_2 <- c(length(nmAll[nmAll %in% grep(measures[2], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[2], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=3)
measures_3 <- c(length(nmAll[nmAll %in% grep(measures[3], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[3], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=4)
measures_4 <- c(length(nmAll[nmAll %in% grep(measures[4], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[4], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=5)
measures_5 <- c(length(nmAll[nmAll %in% grep(measures[5], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[5], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=6)
measures_6 <- c(length(nmAll[nmAll %in% grep(measures[6], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[6], nmPers, value=TRUE)])/nmPersLen*normMax)
if(length(measures)>=7)
measures_7 <- c(length(nmAll[nmAll %in% grep(measures[6], nmAll, value=TRUE)])/nmAllLen*normMax,
                length(nmPers[nmPers %in% grep(measures[6], nmPers, value=TRUE)])/nmPersLen*normMax)

# construct values vector
if(length(measures) == 5) 
    measuresVector <- c(measures_1, measures_2, measures_3, measures_4, measures_5)
if(length(measures) == 6) 
    measuresVector <- c(measures_1, measures_2, measures_3, measures_4, measures_5, measures_6)
if(length(measures) == 7) 
    measuresVector <- c(measures_1, measures_2, measures_3, measures_4, measures_5, measures_6, measures_7)


# add total number of members
lenVector <- c(nmAllLen, nmPersLen)
measuresLab <- paste(measuresLab, "\n(", lenVector, " part.)", sep="")

# construct matrix to plot
plotMatrix <- matrix(measuresVector,
                nrow = 2, ncol = length(measures), byrow = FALSE,
                dimnames = list(legendLab, measuresLab))

# if "saveFile", than save as png image:
if (saveFile) png(paste(fileName, "png", sep="."), width=700, height=700)

#Plot parameters
par(mai = c(1.2, 1.2, 0.7, 0)) # margin size (bottom, left, top, right) specified in inches. 
par(mgp = c(4.5, 3, 0)) # margin line for (the axis title, axis labels, axis line)
par(cex.lab = 1.2) # label size 

#Draw Plot
barplot(plotMatrix, beside = TRUE, cex.names = 1.0, axis.lty = 0,
        col = c("lightskyblue", "palegreen"),
        main=mainText, ylab=ylabText, xlab=xlabText,
        legend = rownames(plotMatrix),
        ylim = c(0, normMax))
grid(0, 10)

# if "saveFile", stop output-redirection to file
if (saveFile) dev.off()

}

#Function call with different parameters
isSaveFile <- TRUE
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "small", "design")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "small", "impl")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "small", "test")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "small", "main")

fossanalyze.measure_proj_vs_pers_people(isSaveFile, "big", "design")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "big", "impl")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "big", "test")
fossanalyze.measure_proj_vs_pers_people(isSaveFile, "big", "main")
